



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>自定义控件：抽屉SlidingDrawer——wrap_content非全屏</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">自定义控件：抽屉SlidingDrawer——wrap_content非全屏</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 16:37:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/376754/201409/301306337229996.jpg" /></p>
<p>android:allowSingleTap &nbsp;&nbsp;指示抽屉是否可以打开/通过手柄上的一个水龙头关闭。</p>
<p>android:animateOnClick &nbsp;<em>表示所述抽屉是否应该打开/与当用户点击手柄动画关闭。&nbsp;&nbsp; &nbsp; &nbsp;</em></p>
<p><em>android:bottomOffset &nbsp; &nbsp; 额外偏移的把手在SlidingDrawer的底部。<br />android:content &nbsp;&nbsp;标识符表示抽屉的内容孩子。</em></p>
<p>Identifier for the child that represents the drawer's content.&nbsp;<br />android:handle &nbsp; &nbsp;&nbsp;标识符表示抽屉的把手的孩子。</p>
<p>Identifier for the child that represents the drawer's handle. <br />android:orientation</p>
<p>Orientation of the SlidingDrawer. &nbsp;取向SlidingDrawer的。<br />android:topOffset</p>
<p>Extra offset for the handle at the top of the SlidingDrawer.</p>
<p>额外偏移的把手在SlidingDrawer的顶部。</p>
<div>
<pre class="prettyprint linenums"><strong> import android.content.Context;<br />
 import android.util.AttributeSet;<br />
 import android.view.View;<br />
 import android.widget.SlidingDrawer;

 /**<br />
  * 使得SlidingDrawer在屏幕低端，而不会填满整个屏幕<br />
  */<br />
 public class WrapSlidingDrawer extends SlidingDrawer {

     private boolean mVertical;<br />
     private int mTopOffset;

     // 从指定的XML定义的属性集创建一个新的WrapSlidingDrawer。<br />
     public WrapSlidingDrawer(Context context, AttributeSet attrs, int defStyle) {<br />
         super(context, attrs, defStyle);<br />
         /**<br />
          * namespace     属性的命名空间来获取。<br />
          * attribute     属性检索。<br />
          * defaultValue     如果未找到该属性返回什么。<br />
          *<br />
          * ORIENTATION_VERTICAL:定向垂直。<br />
          */<br />
         int orientation = attrs.getAttributeIntValue("android", "orientation",<br />
                 ORIENTATION_VERTICAL);<br />
         // "topOffset" 额外偏移的把手在SlidingDrawer的顶部。<br />
         mTopOffset = attrs.getAttributeIntValue("android", "topOffset", 0);<br />
         mVertical = (orientation == SlidingDrawer.ORIENTATION_VERTICAL);<br />
     }

     public WrapSlidingDrawer(Context context, AttributeSet attrs) {<br />
         super(context, attrs);<br />
         int orientation = attrs.getAttributeIntValue("android", "orientation",<br />
                 ORIENTATION_VERTICAL);<br />
         mTopOffset = attrs.getAttributeIntValue("android", "topOffset", 0);<br />
         mVertical = (orientation == SlidingDrawer.ORIENTATION_VERTICAL);<br />
     }

     /**<br />
      * 测量视图和其内容，以确定所测量的宽度和所测量的高度。<br />
      * widthMeasureSpec   宽度测量规格。<br />
      * heightMeasureSpec  高度测量规格。<br />
      */<br />
     @Override<br />
     protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {<br />
         int widthSpecMode = MeasureSpec.getMode(widthMeasureSpec);<br />
         int widthSpecSize = MeasureSpec.getSize(widthMeasureSpec);<br />
         int heightSpecMode = MeasureSpec.getMode(heightMeasureSpec);<br />
         int heightSpecSize = MeasureSpec.getSize(heightMeasureSpec);<br />
         // 返回抽屉的手柄。<br />
         final View handle = getHandle();<br />
         // 返回抽屉的内容。<br />
         final View content = getContent();<br />
         /**<br />
          * Ask one of the children of this view to measure itself, taking into<br />
          * account both the MeasureSpec requirements for this view and its padding.<br />
          * The heavy lifting is done in getChildMeasureSpec.<br />
          *<br />
          * @param child The child to measure<br />
          * @param parentWidthMeasureSpec The width requirements for this view<br />
          * @param parentHeightMeasureSpec The height requirements for this view<br />
          */<br />
         measureChild(handle, widthMeasureSpec, heightMeasureSpec);

         if (mVertical) {<br />
             // 测量高度 - 抽屉手柄高度 - 额外偏移的把手顶部<br />
             int height = heightSpecSize - handle.getMeasuredHeight()<br />
                     - mTopOffset;<br />
             // 内容尺寸<br />
             // public static int makeMeasureSpec (int size, int mode)<br />
             // Creates a measure specification based on the supplied size and mode.<br />
             //   size    the size of the measure specification<br />
             //   mode    the mode of the measure specification<br />
             content.measure(widthMeasureSpec,<br />
                     MeasureSpec.makeMeasureSpec(height, heightSpecMode));<br />
             //<br />
             heightSpecSize = handle.getMeasuredHeight() + mTopOffset<br />
                     + content.getMeasuredHeight();<br />
             //<br />
             widthSpecSize = content.getMeasuredWidth();<br />
             //<br />
             if (handle.getMeasuredWidth() &gt; widthSpecSize)<br />
                 widthSpecSize = handle.getMeasuredWidth();<br />
         } else {<br />
             int width = widthSpecSize - handle.getMeasuredWidth() - mTopOffset;<br />
             getContent().measure(<br />
                     MeasureSpec.makeMeasureSpec(width, widthSpecMode),<br />
                     heightMeasureSpec);<br />
             widthSpecSize = handle.getMeasuredWidth() + mTopOffset<br />
                     + content.getMeasuredWidth();<br />
             heightSpecSize = content.getMeasuredHeight();<br />
             if (handle.getMeasuredHeight() &gt; heightSpecSize)<br />
                 heightSpecSize = handle.getMeasuredHeight();<br />
         }<br />
         // 此方法必须由onMeasure（int，int）被调用储存的测量宽度和高度测量。<br />
         setMeasuredDimension(widthSpecSize, heightSpecSize);<br />
     }<br />
 }</strong></pre>
</div>
<div>
<pre class="prettyprint linenums"><strong> &lt;?xml version="1.0" encoding="utf-8"?&gt;<br />
 &lt;RelativeLayout xmlns:android="http://schemas.android.com/apk/res/android"<br />
     android:layout_width="fill_parent"<br />
     android:layout_height="fill_parent" &gt;

     &lt;TextView<br />
         android:id="@+id/text_view"<br />
         android:layout_width="fill_parent"<br />
         android:layout_height="wrap_content"<br />
         android:layout_marginTop="10dip"<br />
         android:gravity="center"<br />
         android:text="AAAAAAAAAAAAAA"<br />
         android:textSize="10pt" /&gt;

     &lt;com.cn.daming.WrapSlidingDrawer<br />
         android:id="@+id/sliding_drawer"<br />
         android:layout_width="fill_parent"<br />
         android:layout_height="wrap_content"<br />
         android:content="@+id/mycontent"<br />
         android:handle="@+id/layout1"<br />
         android:layout_alignParentBottom="true"<br />
         android:orientation="vertical" &gt;

         &lt;LinearLayout<br />
             android:id="@id/layout1"<br />
             android:layout_width="wrap_content"<br />
             android:layout_height="wrap_content"<br />
             android:background="#00000000"<br />
             android:gravity="center" &gt;

             &lt;ImageView<br />
                 android:id="@+id/my_image"<br />
                 android:layout_width="wrap_content"<br />
                 android:layout_height="wrap_content"<br />
                 android:src="@drawable/up1" /&gt;<br />
         &lt;/LinearLayout&gt;

         &lt;GridView<br />
             android:id="@id/mycontent"<br />
             android:layout_width="wrap_content"<br />
             android:layout_height="wrap_content"<br />
             android:background="#ff000000"<br />
             android:gravity="center"<br />
             android:numColumns="3"<br />
             android:paddingTop="20dip" /&gt;<br />
     &lt;/com.cn.daming.WrapSlidingDrawer&gt;

 &lt;/RelativeLayout&gt;</strong></pre>
</div>
<div>
<pre class="prettyprint linenums"><strong><br />
 import android.app.Activity;<br />
 import android.content.res.Configuration;<br />
 import android.os.Bundle;<br />
 import android.view.View;<br />
 import android.widget.GridView;<br />
 import android.widget.ImageView;<br />
 import android.widget.SlidingDrawer;<br />
 import android.widget.TextView;

 public class SlidingDrawerMainActivity extends Activity {

     private GridView gridView;<br />
     private SlidingDrawer slidingDrawer;<br />
     private ImageView imageView;<br />
     private TextView textview;<br />
     private int[] icons = { R.drawable.title1, R.drawable.title2,<br />
             R.drawable.title3, R.drawable.title4, R.drawable.title5,<br />
             R.drawable.title6 };

     private String[] items = { "Phone", "Message", "AddImage", "Music",<br />
             "Telephone", "SMS" };

     @Override<br />
     public void onCreate(Bundle savedInstanceState) {<br />
         super.onCreate(savedInstanceState);

         setContentView(R.layout.main);

         gridView = (GridView) findViewById(R.id.mycontent);<br />
         slidingDrawer = (SlidingDrawer) findViewById(R.id.sliding_drawer);<br />
         imageView = (ImageView) findViewById(R.id.my_image);<br />
         textview = (TextView) findViewById(R.id.text_view);<br />
         MyGridViewAdapter adapter = new MyGridViewAdapter(this, items, icons);<br />
         gridView.setAdapter(adapter);

         slidingDrawer<br />
                 .setOnDrawerOpenListener(new SlidingDrawer.OnDrawerOpenListener() {

                     public void onDrawerOpened() {<br />
                         textview.setVisibility(View.GONE);<br />
                         imageView.setImageResource(R.drawable.down1);<br />
                     }<br />
                 });<br />
         slidingDrawer<br />
                 .setOnDrawerCloseListener(new SlidingDrawer.OnDrawerCloseListener() {

                     public void onDrawerClosed() {<br />
                         textview.setVisibility(View.VISIBLE);<br />
                         imageView.setImageResource(R.drawable.up1);<br />
                     }<br />
                 });<br />
     }

     @Override<br />
     public void onConfigurationChanged(Configuration newConfig) {<br />
         super.onConfigurationChanged(newConfig);<br />
     }<br />
 }</strong></pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/376754/201409/301319334728748.png" /></p>
<p>完整代码下载：http://pan.baidu.com/s/1sjsdqTv</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnjd3k8.html">mysqldump和xtrabackup备份原理实现说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96pym48.html">基于SSM的租赁管理系统0&period;1&lowbar;20161225&lowbar;项目需求</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7d73xq.html">低版本的xcode打开xcode8上的xib错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93e6lwq.html">mongodb与sql语句对照表</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okv7xp9.html">C&num;打包制作安装程序过程全记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w02kwq.html">浅谈C&num;中ref与out的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x41r09.html">Jsp笔记（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95005pe8.html">Oracle &plus; EF5 疑难杂症</a>
		</li>
						<li><a href="https://www.batexi.com/a/950d2oe8.html">【EntityFramework 6&period;1&period;3】个人理解与问题记录（3）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlloexxq.html">Centos7安装Tomcat8</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjmpd69.html">反射reflect</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy4dzdq.html">为什么 管理工具里没有Internet&lpar;IIS&rpar;管理器选项</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv02d28.html">EZ 2018 06 10 NOIP2018 模拟赛（十八）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvxxgy8.html">定义类型别名&lpar;typedef&comma;using&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zypo2v9.html">096实战 在windows下新建maven项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/963p4m39.html">&lbrack;转&rsqb;php-mobile-detect</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2xr0e8.html">MyBatis接口的简单实现原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2korovq.html">&lbrack;转&rsqb;如何在 JS 代码中消灭 for 循环</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e0moymq.html">http&colon;&sol;&sol;imgbase64&period;duoshitong&period;com&sol;     图片转换 base64</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxly33vq.html">linux lvs 配置</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyd506gq.html">&lbrack;shell编程&rsqb;初识sed和gawk</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z14xg19.html">&lbrack;主席树&rsqb;HDOJ4348 To the moon</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z14x339.html">日志工具logback的简介与配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdez3nz9.html">Shell脚本的编写</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vp0k48.html">2014-9-17二班----10 web project</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okg0wp9.html">想要风投被你的融资 PPT 打动吗？别忘了你其实就是在想方设法卖出自己公司的部分股权</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmk3yx9.html">linux PATH环境变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1yx438.html">车牌识别LPR系统系列文章汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmk4xe9.html">BZOJ 2154 Crash的数字表格</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z14wmn9.html">Android开发之ActivityManager获取系统信息</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
